//////////////////////////////////////////////////////////////////////////////////////
//																					//
//			SakuraFMOǂݎpTvNXiSakuraFMOReader.hj				//
//																					//
//												Last Update 2015/03/01  by yasi		//
//																					//
//////////////////////////////////////////////////////////////////////////////////////

#ifndef _SAKURA_FMO_READER_H_
#define _SAKURA_FMO_READER_H_

#include <windows.h>
#include <string>
#include <tchar.h>

// ReadFMOԂl`
#define SAKURA_FMO_READ_OK			0x00000000	// Ǎ
#define SAKURA_FMO_NOT_MUTEX_HANDLE 0x00000001	// Mutexnh擾
#define SAKURA_FMO_MUTEX_TIME_OUT	0x00000002	// Mutex҂^CAEg
#define SAKURA_FMO_MUTEX_ERRER		0x00000004	// WaitForSingleObjectG[
#define SAKURA_FMO_OPEN_ERRER		0x00000008	// FMOI[vG[iFMO݂Ȃꍇ܂ށj
#define SAKURA_FMO_VIEW_ERROR		0x00000010	// FMO}bsOG[
#define SAKURA_FMO_UNICODE_ERROR	0x00000020	// UNICODEG[
#define SAKURA_FMO_EXCEPTION_ERROR	0xFFFFFFFF	// OG[


#define	SAKURA_API_MESSAGE			_T("Sakura")	// WM_SAKURAAPI

#define SAKURA_API_GHOSTCHANGE		1024			// S[Xg`FWu[hLXgwParaml

typedef std::basic_string<TCHAR, std::char_traits<TCHAR>, std::allocator<TCHAR> > _tstring;

class CSakuraFMOReader
{
private:
	// oϐ
	_tstring		m_sFMOName;			// FMO
	_tstring		m_sMutexName;		// Mutex
	unsigned long	m_iOldSize;			// FMOf[^TCY
	HANDLE			m_hMutex;			// Mutexnh
	bool			m_bCreateTextFlag;	// eLXgf[^쐬tO
	
protected:

	_tstring		m_sFMOStr;			// FMOeLXgf[^
	unsigned long	m_iFMOSize;			// FMOf[^TCY
	LPSTR			m_pFMOData;			// FMOf[^

	virtual UINT	TransrateText();	// eLXgf[^z֐BftHgł͐擪4oCgeLXgf[^쐬܂B_UNICODE`ĂꍇUNICODEs܂B

public:

	CSakuraFMOReader();													// RXgN^
	virtual			~CSakuraFMOReader();								// fXgN^ẢMutexnhN[Y܂
	bool			SetFMOName( LPCTSTR name );							// FMOZbgAMutexnh擾܂
	void			SetCreateTextFlag( bool flag );						// eLXgf[^𐶐邩ǂ̃tOZbg܂Bltrue
	bool			GetCreateTextFlag();								// eLXgf[^𐶐邩ǂ݂̌̃tOl擾܂
	UINT			ReadFMO();											// FMOf[^擾܂
	unsigned long	GetFMOSize();										// GetDataŎ󂯎̂ɕKvȃoCgԂ܂
	bool			GetData( BYTE *buf, const unsigned long bufSize );	// FMOSf[^BYTE^ŕԂ܂B͎󂯎BYTE^z|C^Ƃ̃obt@TCY
	unsigned long	GetTextSize();										// GetTextŎ󂯎̂ɕKvȕI['\0'܂ޕԂ܂
	bool			GetText( LPTSTR buf, const unsigned long bufSize );	// FMOf[^𕶎ŕԂ܂BFMOTCY\擪4oCg͊܂܂܂B͎󂯎TCHAR^z|C^Ƃ̃obt@TCY
	_tstring		GetString();										// GetTexttstring
	void			CloseMutexHandle();									// IMutexnhN[Y܂
};

UINT GetSakuraAPIMsg();		// WM_SAKURAAPI̒l擾܂B

#endif // !_SAKURA_FMO_READER_H_

/////////////////////////////////////////////////////////////////////////////////////////////////////
// SakuraFMOdli2015/03/01݁j
// 
// ͎̃U΂Ădlɂ܂Ƃ߂AyasǐlIȃł܂B
//   dlł͂܂̂ŊԈႢ邩܂BӂĂB
/////////////////////////////////////////////////////////////////////////////////////////////////////
/*

@Tv

	SakuraFMO݂͌̃S[XgԒʒmvZXԋLf[^ƂĎgpĂt@C}bsOIuWFNgB


@FMOANZXɊւ戵

	SakuraFMO̓T[o[ix[XEFAjyѐݒɂقȂꍇB
	SSPFMOl"Sakura"ŁA{̐ݒɂύX\B

	FMOփANZX鎞͕KMutexgpAvZXƂ̓ANZXsȂ悤rsB
	Mutex́wFMO + "FMO"xŁASSP̏LlŌ"SakuraFMO"MutexƂȂB
	FMOύXĂ̂ł΁wύXFMO + "FMO"x

	Mutexnh̎擾EN[YSakuraFMO擾ɖsKv͂ȂAɕKvȂ΃vZXJnɎ擾A
	IɃN[Y΂悢BiN[YȂĂvZXIɎIɃN[Yj

	MutexLiWaitForSingleObjectjiReleaseMutexj܂ł͂ȂׂZԂŏς܂悤ɂB
	Ⴆ΁AǍ݂̂łΓẽRs[sA͏MutexReleaseɍs悤ɂB
	AA݂sKv̂vZXłMutexLǍ́݁Mutex܂ł1ZNVƂčsB
	Mutex_œǍ񂾃f[^͉ߋ̃f[^ł鎖ӎȂ΂ȂȂB

	MutexL̗OG[ɂMutex͂񂾂܂܃vZXIȂ悤ȏsB
	Cłtry{}catch{}pMutexKs悤ɂB

	ÃvZXMutexL܂܈ُIƁAWaitForSingleObjectWAIT_ABANDONEDԂA
	ďovZXɏLڂB
	YĒPWAIT_OBJECT_0ƔrMutexȂ܂܁AʃvZX߂ȂԂɊׂ̂ŒӂB


@SakuraFMO\f[^

@EFMOf[^TCY
	SakuraFMOFMÖ͉ϒlŁAFMO̐擪4oCgFMÖ̃TCYi擪4oCg܂ށjlonglŋL^ĂB
	炭ex[XEFA64*1024oCgŒ肾dl኱BŁAƌŒƂ͌ȂB
	ABottlenAvł͉ϒlĂ镨̂ŕK擪4oCgmFƎvB
	A܂FMÖƂĊmۂĂŜ̃TCYłAFMÖSĂɗLȃf[^܂ĂƂ͌ȂB
	܂ALf[^TCY  FMÖTCY

@E}bvf[^
	[4oCg(FMÖTCYFlongl)][f[^{]

@Ef[^{̃tH[}bg
	entry[0x01(SHO)]value[0x0d(CR)][0x0a(LF)]
	1Gg[ƂGg[̘Af[^
	entry[1vZXiS[XgjɊU郆j[Nl.tB[h]ō\
	SSP̏ꍇ́wssp_fmo_header_[vZXID-16i]_[Sakurahwnd-16i].[tB[h][0x01][l][0x0d][0x0a]x1Gg[B
	Fssp_fmo_header_000002a5_002b3132.name[1]Emily\r\n

	1S[Xgɑ΂Gg[̓x[XEFAɂĈقȂꍇ̂ŒӁB
	SSP1S[Xg̃Gg[9ōڂ

	j[Nl.path				x[XEFApX
	j[Nl.hwnd				sakura10ihwndiC̃EBhEnhBKDirectSSTPT[o[@\Ăj
	j[Nl.name				sakuraL
	j[Nl.keroname			keroL
	j[Nl.sakura.surface	݂sakurasurfaceID
	j[Nl.kero.surface		݂kerosurfaceID
	j[Nl.kerohwnd			kero10ihwnd
	j[Nl.hwndlist			sakuraAkero܂hwndXgisakurai\0j珇ɃJ}؂10ihwndj
	j[Nl.ghostpath		S[XgtH_pX

	dl̗LȃGg[hwnd][name][keroname][sakura.surface][kero.surface]5݂̂LĂ邾Ȃ̂ŁA
	ɂΉꍇ̓Gg[ƃtB[hiej̈ɒӂKvB

	i݂ɁAf[^{̂̏I[0x00inulljŏI鎖ۏႵĂLq͎dl͌󂯂Ȃcj

@SakuraFMO̕ύXʒm

	IFMOǂōXV͍̂RXgȂ̂SAKURA APIƓEBhEbZ[WpĒʒmA
	yю擾^C~Om鎖łB
	󂯎pł

	#define SAKURA_API_BROADCAST_GHOSTCHANGE	1024
	UINT uSakuraAPIMsg = RegisterWndowMessage("Sakura");

	int CALLBACK WindowProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam ){
		if( uMsg == uSakuraAPIMsg ){
			if( wParam == SAKURA_API_BROADCAST_GHOSTCHANGE ){
				// `FMO擾`
			}
		}
		// `ȉȗ`
	}

	ŃS[Xg`FW̃^C~Oɍ킹FMO擾łB
	݂SAKURA API͌XSakuraFMOƒڊ֌WȂʐMKiȂ̂ŁAFMOύXĂĂ
	RegisterWndowMessage()̈"Sakura"ŒB

	SSPu[hLXgő̂͂̃S[Xg`FŴ݂ƎvASSPNAyяIɂĂB
	ڂ ʂłׂ SSP/dl/FMO QƁB
	http://emily.shillest.net/specwiki/index.php?SSP%2F%E4%BB%95%E6%A7%98%E6%9B%B8%2FFMO


@LQlTCg
	ʂłׂ		http://emily.shillest.net/specwiki/index.php?FrontPage
		http://usada.sakura.vg/
	SSTP BOTTLE		http://bottle.mikage.to/index.html

*/