//////////////////////////////////////////////////////////////////////////////////////
//																					//
//			SakuraFMOǂݎpTvNXiSakuraFMOReader.cppj				//
//																					//
//												Last Update 2015/03/01  by yasi		//
//																					//
//////////////////////////////////////////////////////////////////////////////////////

#include "SakuraFMOReader.h"

/////////////////////////////////////////////////////////////////////////////////
// public֐
/////////////////////////////////////////////////////////////////////////////////

// RXgN^
CSakuraFMOReader::CSakuraFMOReader()
{
	m_hMutex = NULL;
	m_pFMOData = NULL;
	m_iFMOSize = 0;
	m_iOldSize = 0;
	m_bCreateTextFlag = true;
}

// fXgN^FJMutexnhN[Y܂B
CSakuraFMOReader::~CSakuraFMOReader()
{
	if( m_pFMOData != NULL ){
		delete [] m_pFMOData;
		m_pFMOData = NULL;
	}
	// Mutexnh
	CloseMutexHandle();
}

// FMOZbgAMutexnh擾܂B
// ԂlFbool
// true = Ffalse = s
// CSakuraFMOReaderIuWFNg쐻AReadFMO()sOɈx͍sKv܂B
// sMutexnhCloseHandleȂ薈sKv͂܂B
bool CSakuraFMOReader::SetFMOName( LPCTSTR name )
{
	// sMutexnhN[Y
	CloseMutexHandle();
	m_sFMOName = name;
	m_sMutexName = name;
	m_sMutexName += _T("FMO");
	// Mutexnh擾
	m_hMutex = CreateMutex( NULL, FALSE, m_sMutexName.c_str() );
	if( m_hMutex == NULL ) return false;
	return true;
}

// eLXgf[^𐶐邩ǂ̃tOZbg܂B
// TEXTf[^KvȂꍇfalseɂ鎖ReadFMO()̏኱I܂B
// Fbool
// true = iljFfalse = Ȃ
// falseݒ肳ꂽ_ŃNXɕۑĂeLXgf[^͏܂B
// eLXgf[^ւ̃ANZXƃtOZbg̃^C~Oɂ͒ӂĂB
void CSakuraFMOReader::SetCreateTextFlag( bool flag )
{
	// falseł΃eLXgf[^󕶎
	if( !flag ){
		m_sFMOStr = _T("");
	}
	m_bCreateTextFlag = flag;
}

// eLXgf[^𐶐邩ǂ݂̌̃tOl擾܂B
// ԂlFbool
// true = Ffalse = Ȃ
bool CSakuraFMOReader::GetCreateTextFlag()
{
	return m_bCreateTextFlag;
}

// FMOf[^擾܂B
// ԂlFUINT
// ꍇ0Asꍇ͂ȊO̐lԂ܂B
// Ԃlȅڍׂ̓wb_t@CReadFMOԂl`mFĂB
// SAKURA_FMO_EXCEPTION_ERRORԂꂽ̃AvP[V̏ɂ͏\ӂĂB
// SAKURA_FMO_MUTEX_ERRERԂꂽꍇGetLastError()ŃG[擾ł܂B
// SAKURA_FMO_UNICODE_ERRORԂ鎖̂̓eLXgf[^tOtrue̎A_UNICODE`Ăꍇ݂̂łB
// SAKURA_FMO_UNICODE_ERRORԂꂽꍇAGetData瓾錋ʂGetText瓾錋ʂقȂ܂BӂĂB
UINT CSakuraFMOReader::ReadFMO()
{
	HANDLE	hFMO = NULL;
	LPVOID	pMapAdrs = NULL;

	if( m_hMutex == NULL )
		return SAKURA_FMO_NOT_MUTEX_HANDLE;

	// MutexVOi҂
	DWORD res = WaitForSingleObject( m_hMutex, 1000 );
	if( res == WAIT_FAILED )
		return SAKURA_FMO_MUTEX_ERRER;
	if( res != WAIT_TIMEOUT ){
		// MutexJ΍
		try{
			// FMOnh擾
			hFMO = OpenFileMapping( FILE_MAP_READ, FALSE, m_sFMOName.c_str() );
			if( hFMO == NULL ){
				ReleaseMutex( m_hMutex );
				return SAKURA_FMO_OPEN_ERRER;
			}
			// FMOWJi}bsOj
			pMapAdrs = MapViewOfFile( hFMO, FILE_MAP_READ, 0, 0, 0 );
			if( pMapAdrs == NULL ){
				CloseHandle( hFMO );
				ReleaseMutex( m_hMutex );
				return SAKURA_FMO_VIEW_ERROR;
			}
			// FMOTCY擾
			memcpy_s( &m_iFMOSize, sizeof( m_iFMOSize ), pMapAdrs, 4 );
			
			// `FbN
			if( m_pFMOData != NULL ){
				// TCY`FbNAKvł΃EĊm
				if( m_iFMOSize != m_iOldSize ){
					delete [] m_pFMOData;
					m_pFMOData = NULL;
					m_pFMOData = new char[ m_iFMOSize + 1 ];
					m_iOldSize = m_iFMOSize;
				}
			}else{
				m_pFMOData = new char[ m_iFMOSize + 1 ];
				m_iOldSize = m_iFMOSize;
			}

			// charzփRs[
			memset( m_pFMOData, 0x00, m_iFMOSize + 1 );
			memcpy_s( m_pFMOData, m_iFMOSize + 1, pMapAdrs, m_iFMOSize );

			// nhJ
			UnmapViewOfFile( pMapAdrs );
			pMapAdrs = NULL;
			CloseHandle( hFMO );
			hFMO = NULL;
			ReleaseMutex( m_hMutex );

		}catch(...){ // Oiej
			if( pMapAdrs != NULL ){
				UnmapViewOfFile( pMapAdrs );
				pMapAdrs = NULL;
			}
			if( hFMO != NULL ){
				CloseHandle( hFMO );
				hFMO = NULL;
			}
			ReleaseMutex( m_hMutex );
			return SAKURA_FMO_EXCEPTION_ERROR;
		}
		// eLXgf[^쐬tO`FbN
		if( m_bCreateTextFlag )
			return TransrateText();

		return SAKURA_FMO_READ_OK;
	}
	return SAKURA_FMO_MUTEX_TIME_OUT;
}

// GetDataŎ󂯎̂ɕKvȃoCgԂ܂B
// ԂlFlong
// FMO擾OɌĂяo0Ԃ܂B
unsigned long CSakuraFMOReader::GetFMOSize()
{
	return m_iFMOSize;
}

// FMOSf[^󂯎BYTE^obt@֊i[߂܂B
// FBYTEz|C^iobt@AhXjFconst longiobt@TCYj
// ԂlFbool
// true = Ffalse = sinꂽobt@TCYȂꍇ܂ށj
bool CSakuraFMOReader::GetData( BYTE *buf, const unsigned long bufSize )
{
	// obt@TCY`FbN
	if( bufSize < m_iFMOSize )
		return false;
	// Rs[
	if( memcpy_s( buf, bufSize, m_pFMOData, m_iFMOSize ) == 0 )
		return true;
	return false;
}

// GetTextŎ󂯎̂ɕKvȕI['\0'܂ޕԂ܂B
// ԂlFlong
// eLXgf[^쐬tOfalseݒ肳Ăꍇ0Ԃ܂B
unsigned long CSakuraFMOReader::GetTextSize()
{
	// eLXgf[^tO`FbN
	if( !m_bCreateTextFlag )
		return 0;
	return m_sFMOStr.size() + 1;
}

// FMOf[^󂯎TCHAR^obt@֊i[߂܂B
// FTCHARz|C^iobt@AhXjFconst longiobt@TCYj
// ԂlFbool
// true = Ffalse = sinꂽobt@TCYȂꍇ܂ށj
// eLXgf[^쐬tOfalseݒ肳ĂꍇfalseԂ܂B
// ̊֐Ŏ擾łf[^ɂFMOTCY\擪4oCg͊܂܂܂B
bool CSakuraFMOReader::GetText( LPTSTR buf, const unsigned long bufSize )
{
	// eLXgf[^tO`FbN
	if( !m_bCreateTextFlag )
		return false;
	// obt@TCY`FbN
	if( bufSize < m_sFMOStr.size() + 1 )
		return false;
	// Rs[
	if( _tcscpy_s( buf, bufSize, m_sFMOStr.c_str() ) == 0 )
		return true;
	return false;
}

// GetTexttstring
// eLXgf[^쐬tOfalseݒ肳ĂꍇA_tstringԂ܂B
_tstring CSakuraFMOReader::GetString()
{
	return m_sFMOStr;
}

// MutexnhN[Y܂
// ̊֐̓fXgN^łĂ΂܂B
// IɃN[YꍇɌĂяoĂB
// IN[YɍēxReadFMOꍇ́ASetFMONameďoMutexnh擾ȂĉB
void CSakuraFMOReader::CloseMutexHandle()
{
	if( m_hMutex != NULL ){
		CloseHandle( m_hMutex );
		m_hMutex = NULL;
		m_sFMOName = _T("");
		m_sMutexName = _T("");
	}
}

/////////////////////////////////////////////////////////////////////////////////
// protected֐
/////////////////////////////////////////////////////////////////////////////////

// eLXgf[^z֐BftHgł͐擪4oCgeLXgf[^쐬܂B
// _UNICODE`ĂꍇUNICODEs܂B
UINT CSakuraFMOReader::TransrateText()
{

#ifdef _UNICODE

		// UNICODEϊ
		int Len = 0;
		if( ( Len = ::MultiByteToWideChar( CP_ACP, 0, m_pFMOData + 4, -1, NULL, 0 ) ) == 0 )
			return SAKURA_FMO_UNICODE_ERROR;
		LPWSTR buf = new wchar_t[ Len ];
		if( ::MultiByteToWideChar( CP_ACP, 0,m_pFMOData + 4, -1, buf, Len ) == 0 ){
			delete [] buf;
			buf = NULL;
			return SAKURA_FMO_UNICODE_ERROR;
		}

		// oϐ֊i[Eobt@
		m_sFMOStr = buf;
		delete [] buf;
		buf = NULL;
#else
		m_sFMOStr = m_pFMOData + 4;
#endif // _UNICODE

		return SAKURA_FMO_READ_OK;
}

/////////////////////////////////////////////////////////////////////////////////
// NXO֐
/////////////////////////////////////////////////////////////////////////////////

// WM_SAKURAAPI̒l擾܂B
// ԂlFUINTiRegisterWindowMessage("Sakura")Ԃj
UINT GetSakuraAPIMsg()
{
	return RegisterWindowMessage( SAKURA_API_MESSAGE );
}
